require 'spec_helper'

describe TyreshopperSqs2cb::MessageHandler do

  it "should instantiate a new class" do
    TyreshopperSqs2cb::MessageHandler.new.should be_kind_of TyreshopperSqs2cb::MessageHandler
  end

  context "handling message" do
      before(:each) do
        @awsAccessKeyId = ENV['AWS_ACCESS_KEY']
        @awsSecretAccessKey = ENV['AWS_SECRET_ACCESS_KEY']
        @caseBlocksAPIEndpoint = ENV['CB_API_ENDPOINT']
        @caseBlocksAPIToken = ENV['CB_API_TOKEN']
        @caseBlocksQueue = ENV['CB_QUEUE']
        @usePatchCommand = (@caseBlocksQueue =~ /patch/)
        @stop = false

        @options = {:use_patch_command => @usePatchCommand, :case_blocks_api_endpoint => @caseBlocksAPIEndpoint, :caseblocks_api_token => @caseBlocksAPIToken}
      end

    context "when signed out" do
      before(:each) do
        @json = '{"case":{"signed_in":false,"member":{"email": "stewart@rockwellcottage.com"},"title":"TZ672449","case_type_id":1,"case_type":"tyre-shopper-order","current_state":"Requiring action Risk","order_number":"TZ672449","order_date":"2015-02-24T16:02:44Z","customer":"Mr Stewart McKee","vrn":"YT55 NFO","address1":"Rockwell Cottage","address2":"Main Road","address3":"Cardross","postcode":"G82 5PA","daytime_telephone":"+447968115250","evening_telephone":"+447968115250","email":"stewart@rockwellcottage.com","market_opt_in":false,"payment_type":"Creditcard","transaction_reference":"TZ672449","card_number":"1111","account_holder":"Stewart","streamline_risk_assessment":"0","tyre_shopper_risk_assessment":"37","tyre_shopper_risk_assessment_notes":"Customer name isn''t an exact match of the Streamline cardholder name\nEmail is Hotmail, Yahoo or Gmail\nEmail used in last 6 months\nVRN used in last 6 months\nNumber used in last 6 months\nAlternative phone number used in last 6 months\n","order_source":"TyreShopper","fitting_date":"2015-02-27T00:00:00Z","am_pm":"PM","stock_check":true,"phone_number":"01625 424461","branch_number":"050","mobile_fitting":false,"name":"Macclesfield","line_items":[{"qty":"1","sku":"2055516BU1WX2","price":36.575,"size":"2055516","speed_rating":"W","load_index":94,"description":"WESTLAKE SA05 94W XL"},{"qty":"1","sku":"free_tyre_guarantee","price":0,"size":null,"speed_rating":null,"load_index":0,"description":"Free tyre guarantee"}],"operational_stock":true}}'
      end
      it "does what it says on the tin" do

        message = OpenStruct.new(:body => @json)

        handler = TyreshopperSqs2cb::MessageHandler.new

        puts "handling message...."
        handler.handle_received_message(message, @options);
      end
    end

    context "when signed in" do
      before(:each) do
        @json = '{"case":{"title":"TZ362794","case_type_id":1,"case_type":"tyre-shopper-order","current_state":"Ready for dataflex","order_number":"TZ362794","order_date":"2015-02-26T09:52:47Z","customer":"Mr Stewart McKee","vrn":"YT55 NFO","address1":"Rockwell Cottage","address2":"Main Road","address3":"Cardross","postcode":"G82 5PA","daytime_telephone":"+447968115250","evening_telephone":"+447968115250","email":"stewart@rockwellcottage.com","market_opt_in":false,"payment_type":"PayPal","transaction_reference":null,"card_number":null,"account_holder":null,"streamline_risk_assessment":"0","tyre_shopper_risk_assessment":"0","tyre_shopper_risk_assessment_notes":null,"order_source":"TyreShopper","fitting_date":"2015-02-28T00:00:00Z","am_pm":"PM","stock_check":true,"signed_in":true,"member":{"member_id":"20","group_id":"8","username":"stewart@rockwellcottage.com","screen_name":"stewart@rockwellcottage.com","email":"stewart@rockwellcottage.com","url":"","location":"","occupation":null,"interests":null,"last_visit":"1424703620","last_activity":"1424944270","join_date":"1424700057","first_name":"Stewart","surname":"McKee","opt_in":"","address1":"Rockwell Cottage","address2":"Main Road","town":"Cardross","county":"","daytime_telephone":"+447968115250","postcode":"G82 5PA","evening_telephone":"+447968115250","prefix":"Mr"},"phone_number":"0141 551 8244","branch_number":"102","mobile_fitting":false,"name":"Alexandra Parade","line_items":[{"qty":"1","sku":"2055516BU1WX2","price":36.575,"size":"2055516","speed_rating":"W","load_index":94,"description":"WESTLAKE SA05 94W XL"},{"qty":"1","sku":"free_tyre_guarantee","price":0,"size":null,"speed_rating":null,"load_index":0,"description":"Free tyre guarantee"}],"operational_stock":true}}'
      end
      it "does what it says on the tin" do

        message = OpenStruct.new(:body => @json)

        handler = TyreshopperSqs2cb::MessageHandler.new

        puts "handling message...."
        handler.handle_received_message(message, @options);
      end
    end
  end
end
